#include <stdbool.h>
#include <stdint.h>
#include "hw_init.h"
#include "main.h"
#include "uart_comm.h"
#include "hw_ints.h"
#include "hw_memmap.h"
#include "hw_types.h"
#include "hw_uart.h"
#include "debug.h"
#include "interrupt.h"
#include "rom.h"
#include "sys_ctrl.h"
#include "uart.h"
#include "uartstdio.h"

void RCC_Configuration(void)
{
	//
    // Enable UART peripheral module
    //
    
}

void interrupt_init(void)
{
 // 	IntMasterEnable();
  	//extern io ͷƮ 
//	GPIOIntTypeSet(GPIO_A_BASE, EXAMPLE_GPIO_PIN, GPIO_FALLING_EDGE);  //interrupt fall	
//	GPIOPinIntEnable(GPIO_A_BASE, EXAMPLE_GPIO_PIN);
//	IntEnable(GPIO_A_BASE);  //Ŭ ο̺ 
	
	//sleepmode
//	IntEnable(INT_SMTIM);
	// Set timer to 10000 above current value
    //
  //  ui32Val = SleepModeTimerCountGet();
  //  SleepModeTimerCompareSet(ui32Val + 10000);
	
}

void gpio_init(void)
{
    GPIOPinTypeGPIOInput(GPIO_A_BASE, EXAMPLE_GPIO_PIN);  //input
	//GPIOPinTypeGPIOOutput(GPIO_A_BASE, EXAMPLE_GPIO_PIN);  //output
    IOCPadConfigSet(GPIO_A_BASE, EXAMPLE_GPIO_PIN, IOC_OVERRIDE_PUE);  //pull up
	
   // GPIOPinTypeGPIOInput(GPIO_B_BASE, EXAMPLE_GPIO_PIN);  //input
	//GPIOPinTypeGPIOOutput(GPIO_B_BASE, EXAMPLE_GPIO_PIN);  //output
    //IOCPadConfigSet(GPIO_B_BASE, EXAMPLE_GPIO_PIN, IOC_OVERRIDE_PUE);  //pull up

	//GPIOPinTypeGPIOInput(GPIO_C_BASE, LED_D601_PC0);  //input
	GPIOPinTypeGPIOOutput(GPIO_C_BASE, RUN_LED_PC0 | RF_PA_EN_PC3 | RF_LNA_EN_PC2);  //output
    //IOCPadConfigSet(GPIO_C_BASE, RUN_LED_PC0, IOC_OVERRIDE_PUE);  //pull up
	GPIOPinWrite(GPIO_C_BASE, RUN_LED_PC0, RUN_LED_PC0);	
	GPIOPinWrite(GPIO_C_BASE, RF_PA_EN_PC3 | RF_LNA_EN_PC2, 0);	
	
	//GPIOPinTypeGPIOInput(GPIO_D_BASE, LED_D601_PC0);  //input
	GPIOPinTypeGPIOOutput(GPIO_D_BASE, RF_HGM_PD2);  //output
    //IOCPadConfigSet(GPIO_D_BASE, RUN_LED_PC0, IOC_OVERRIDE_PUE);  //pull up
	GPIOPinWrite(GPIO_D_BASE, RF_HGM_PD2, 0);	
	
	
}

void USART1_Init(uint32_t brate)
{
    // Enable UART peripheral module
  	SysCtrlPeripheralEnable(SYS_CTRL_PERIPH_UART0);
	// Disable UART function
	UARTDisable(UART0_BASE);
    // Set IO clock as UART clock source
	UARTClockSourceSet(UART0_BASE, UART_CLOCK_PIOSC);	
  
  	//232 PA0, PA1
	IOCPinConfigPeriphOutput(GPIO_A_BASE, PA1_PIN_UART_TXD, IOC_MUX_OUT_SEL_UART0_TXD);  //UART1  
    GPIOPinTypeUARTOutput(GPIO_A_BASE, PA1_PIN_UART_TXD); 
    IOCPinConfigPeriphInput(GPIO_A_BASE, PA0_PIN_UART_RXD, IOC_UARTRXD_UART0); //UART1  
    GPIOPinTypeUARTInput(GPIO_A_BASE, PA0_PIN_UART_RXD);
	
	UARTConfigSetExpClk(UART0_BASE, SysCtrlClockGet(), brate,
                        (UART_CONFIG_WLEN_8 | UART_CONFIG_STOP_ONE |
                         UART_CONFIG_PAR_NONE));
		
}