#include "hal_i2c.h"
#include "main.h"
//
// http://e2e.ti.com/support/wireless_connectivity/zigbee_6lowpan_802-15-4_mac/f/158/p/665194/2446718?keyMatch=cc2538%20i2c%20eeprom&tisearch=Search-EN-Everything

void I2C_Master_CMD_Write(unsigned char CommandByte, unsigned char *_data, int _length)
{
	int i;

	I2CMasterSlaveAddrSet(SLAVE_ADDRESS, false);  
  	I2CMasterDataPut(CommandByte); 
  	I2CMasterControl(I2C_MASTER_CMD_BURST_SEND_START);	
	  //wait until done
	  while(I2CMasterBusy());   
	  while(I2CMasterErr());                            // Check the ERROR bit in the I2CM_STAT

	for (int i=0; i<_length; i++)
	{
	  I2CMasterDataPut(_data[i]); 
	  if((_length-1) == i)
			I2CMasterControl(I2C_MASTER_CMD_BURST_SEND_FINISH);
	  else
	  		I2CMasterControl(I2C_MASTER_CMD_BURST_SEND_CONT);
	  //wait until done
	  while(I2CMasterBusy());   
	  while(I2CMasterErr());                            // Check the ERROR bit in the I2CM_STAT
	}  
}

void I2C_Read(unsigned char CommandByte, unsigned char *_pData, int _length)
{
	int i;
	
    // Modifiy the data direction to true, so that seeing the address will
    // indicate that the I2C Master is initiating a read from the slave.
    //
  	I2CMasterSlaveAddrSet(SLAVE_ADDRESS, false);
	I2CMasterDataPut(CommandByte); 	
	I2CMasterControl(I2C_MASTER_CMD_SINGLE_SEND);      
//	I2CMasterControl(I2C_MASTER_CMD_BURST_RECEIVE_START);      
    while(I2CMasterBusy());   
    while(I2CMasterErr());                            // Check the ERROR bit in the I2CM_STAT     		
	I2CMasterSlaveAddrSet(SLAVE_ADDRESS, true);    
	I2CMasterControl(I2C_MASTER_CMD_SINGLE_RECEIVE);
    //wait until done
    while(I2CMasterBusy());   
    while(I2CMasterErr());                            // Check the ERROR bit in the I2CM_STAT         
  for (int i=0; i<_length; i++)
  {
    _pData[i] = I2CMasterDataGet();    //read byte from DR register
/*	if((_length-1) == i)
			I2CMasterControl(I2C_MASTER_CMD_BURST_RECEIVE_FINISH);
	  else
	  		I2CMasterControl(I2C_MASTER_CMD_BURST_RECEIVE_CONT);
*/	
	I2CMasterControl(I2C_MASTER_CMD_SINGLE_RECEIVE);
    //wait until done
    while(I2CMasterBusy());   
    while(I2CMasterErr());                            // Check the ERROR bit in the I2CM_STAT         
  }  
}


void i2c_init_mag3110(void)
{
  unsigned char tmp=0, i;
  unsigned char x_offset[2] = {0x7F, 0xFF};   //0x1FFF 뷫 2000 Ʒ  0x6FFF 뷫 14000  0x7FFF 
  unsigned char y_offset[2] = {0x7F, 0xFF};
  unsigned char z_offset[2] = {0x7F, 0xFF};
  tmp = 0x80;
  I2C_Master_CMD_Write(0x11, &tmp, 1);
  tmp = 0x41; //20 16 320Hz 275uA 0.4noise
  I2C_Master_CMD_Write(0x10, &tmp, 1);
  I2C_Master_CMD_Write(0x09, x_offset, 2);  //x OFFSET
  I2C_Master_CMD_Write(0x0B, y_offset, 2);  //x OFFSET
  I2C_Master_CMD_Write(0x0D, z_offset, 2);  //x OFFSET
      tmp = 0x40; //20 16 320Hz 275uA 0.4noise
 //   tmp = 0x60; //20 16 320Hz 275uA 0.4noise
  I2C_Master_CMD_Write(0x10, &tmp, 1);
 }

void mag3110_read(unsigned char *p_Data)
{
  unsigned char tmp = 0;
  int i = 0;  
  unsigned char mag3110_buf[6];

  tmp = 0x41; //20 16 320Hz 275uA 0.4noise
  I2C_Master_CMD_Write(0x10, &tmp, 1);
  for(i=0;i<200;i++);  
  I2C_Read(0x01, mag3110_buf, 6);
  tmp = 0x40; //20 16 320Hz 275uA 0.4noise
  I2C_Master_CMD_Write(0x10, &tmp, 1);
}