#ifndef __SN_DETECTION_H__
#define __SN_DETECTION_H__

#include "main.h"
#include "tmac_typedefs.h"

// signal levels detection status definitions
#define MLVL_OFF        1
#define MLVL_MID        2
#define MLVL_ON         3

// definitions ---------------------------------------------------
//#define DEBUG_DISPLAY_ON  
// ON, OFF value
#define ON                  MLVL_ON
#define OFF                 MLVL_OFF

//#define DEBUG_ALGO

// detection operation status
#define DET_OPER_IDLE       0
#define DET_OPER_PROC       1

// detection status
#define DET_IDLE	        0
#define DET_PREDETECT	        1
#define DET_DETECT	        2
#define DET_PREIDLE	        3
#define DET_SERCH	        4

//---------------------------------------------------------

#define CTRL_UVDS               0xF6       // 2016.03.23 0xFB --> 0xF4  //2016.02.05 _yj.kwon   // 0xCB       // 2015.11.09 _yj.kwon

// yj.kwon
// New detection parameters
//  򰡼  ϳ  Ķ
// DIFF_ONOFFTH: newly added
#define DET_DIFF_ONOFFTH  30          //40 --> 35(35+25 -> 60) //2015.10.14  25 --> 40 (25+30 --> 55) (40+20 --> 60)  .. //2015.10.13 _yj.kwon

///// Important Info.
#define DET_OFFTH           30          //20 --> 25 // 2015.10.14 _yj.kwon   //30 --> 20 //2015.10.13 _yj.kwon
#define DET_ONTH            (DET_OFFTH+DET_DIFF_ONOFFTH)

#define DET_ONWAIT          2

#define DET_OFFWAIT         300/WAKE_UP_TIME//100         // 250-->400   // 2015.10.13 _yj.kwon

//// Important values
#define DET_BLUP            1300/WAKE_UP_TIME          // //2016.03.12   [10 sec --> 3 sec] 

	#define DET_LONGON      4    //120 jhsong X      // in sec  180 --> 80sec //2015.11.10 _yj.kwon //_3minutes.  90 --> 180 // 2015.10.13 _yj.kwon
	#define DET_LONGON_UPRLMT   65000
	#define DET_LONGONWAIT      3// jhsong Y    // 300 cycle --> 300msec, max 65sec.      // 2015.11.10 _yj.kwon


	#define DET_LONGON_STABLEVAL    40     // jhsong Z   // 3-->5 변?            // 2016.03.21 _yj.kwon
	#define DET_LONGON_STABLEWAIT   300     // 1000-->300ms 변?     // 2016.03.21 _yj.kwon	


// extern declarations ---------------------------------------
extern uint16 det_oper_status;
extern uint16 det_status;
extern uint16 det_seqno;

extern uint16 det_cnt_offwait;
extern uint16 det_cnt_onwait;

extern uint32 det_cnt_blup;      // in idle status
extern uint32 det_cnt_longon;    // in detect status

extern uint16 det_cnt_onreset;

extern uint8 gEventLongOn;      // 2016.02.22 _yj.kwon

extern uint8 gLongOnDet2PreidleCnt;     // 2016.03.20 _yj.kwon


// interfaces ------------------------------------------------
void  detect_init(void);

void detect(void);
void  detect_send_onoff(uint16 sig, uint16 info);
void reset_det_bl(void);

// 2016.02.05 _yj.kwon
void detect_send_on(uint16 sig, uint16 info);

//add jhsong 2017.03.13
#define MAX_SIG 4
extern uint16 sens3_blz[MAX_SIG];
extern uint16 sens_blz_b[MAX_SIG];
extern uint8  dl_car_state;
extern int sens_blz_stopcock[MAX_SIG];

extern int blz_stopcock[MAX_SIG];
extern unsigned int blz_add_tmp[MAX_SIG];
extern unsigned int stopcock_wait_time[MAX_SIG];
extern unsigned int  stopcock_top[MAX_SIG];
extern int car_in_out_vector[MAX_SIG][4];
extern unsigned int blz_add_tmp1[MAX_SIG];
extern uint16 algo_triangle[MAX_SIG][2][3];
extern uint8 algo_triangle_poz;
extern unsigned int det_status_stopcock[MAX_SIG];
//end 


void detect_side_off(uint8 _sel);

/// ˰
#define CAR_NOMAL 0
#define LEFT_TRACE 1
#define RIGHT_TRACE 2
#define CAR_STRONG 3

#define GO_ING     0
#define GO_LEFT     0x01
#define GO_UP       0x02
#define GO_RIGHT    0x04
#define GO_DOWN     0x08
#define GO_LEFT_UP      0x10
#define GO_LEFT_DOWN    0x20
#define GO_RIGHT_UP     0x40
#define GO_RIGHT_DOWN   0x80

extern int diff_value_b[MAX_SIG];
extern unsigned char pattern_force_serch;  //4 
extern unsigned char pattern_sort;
extern unsigned char pattern_sub_flag;
extern unsigned char pattern_4sub_flag;


#endif
