#include "sn_sampling.h"
#include "main.h"
#include "hal_i2c.h"
#include "hal_adc.h"
#include "uart_comm.h"
#include "packet_type.h"
//#include "sn_detection.h"

uint8 mag3110_count=0; 
unsigned int x_result = 0;
unsigned int y_result = 0;
unsigned int z_result = 0;
unsigned int z1_result = 0;
unsigned int bat_result = 0;
uint32 resen_x[5];  
uint32 resen_y[5]; 
uint32 resen_z[7]; 


char check_sig(void)
{
  	char tmp = 0;
	unsigned int dist;
	 if(x_result == 0) tmp = 1;
	 if(y_result == 0) tmp = 1;
	 if(z_result == 0) tmp = 1;
	 if(resen_x[0])
	 {
//	 	dist = util_get_offset(x_result, resen_x[0]);
	 	if(dist > 6000) tmp = 1;
	 }
	 if(resen_y[0])
	 {
//	 	dist = util_get_offset(y_result, resen_y[0]);
	 	if(dist > 6000) tmp = 1;
	 }
	 if(resen_z[0])
	 {
//	 	dist = util_get_offset(z_result, resen_z[0]);
	 	if(dist > 6000) tmp = 1;
	 }
	 return tmp;
}

// SENSOR  -------------------------------------
void det_sensor_read (void)
{
	uint8 mag3110_buf[6];
  	mag3110_read(mag3110_buf);
	x_result = ((mag3110_buf[0]*256+mag3110_buf[1])-38000);
	y_result = ((mag3110_buf[2]*256+mag3110_buf[3])-38000);
	z_result = ((mag3110_buf[4]*256+mag3110_buf[5])-38000);
	x_result = x_result;
	y_result = y_result;
	z_result = z_result;
	if(check_sig())  //̰ ̻Ҷ   			
	{
		x_result = resen_x[0];
		y_result = resen_y[0];
		z_result = resen_z[0];
	}

//	if(util_get_offset(resen_x[4], x_result) < 20)
	x_result = (x_result+resen_x[0]+resen_x[1])/3;
	resen_x[1]= resen_x[0];
	resen_x[0]= x_result;

//	if(util_get_offset(resen_y[4], y_result) < 20)
		y_result = (y_result+resen_y[0]+resen_y[1])/3;	
	resen_y[1]= resen_y[0];
	resen_y[0]= y_result;

//	if(util_get_offset(resen_z[6], z_result) < 35)
		z_result = (z_result+resen_z[0]+resen_z[1]+resen_z[2])/4;
	
	resen_z[2]= resen_z[1];		  
	resen_z[1]= resen_z[0];
	resen_z[0]= z_result;		
	
	ADC_read(mag3110_buf);
	z1_result = mag3110_buf[0] * 256 + mag3110_buf[1];
	bat_result = mag3110_buf[2] * 256 + mag3110_buf[3];

	//diff_value_b[0]=((int)sens_blz_stopcock[0] - x_result); //(int)blz_add_tmp[0] - x_result;//
	//diff_value_b[1]=(int)sens_blz_stopcock[1] - y_result; //(int)blz_add_tmp[1] - y_result;//
}

void rtmon_chk_send(void)
{
  	int tmp = 0;
	BYTE tmp_send_buf[64];
	int size = 0;  	
    
	tmp_send_buf[size++] = config.lora_freq;
	tmp_send_buf[size++] = config.lora_grup;
	tmp_send_buf[size++] = config.sensor_id/256;
	tmp_send_buf[size++] = config.sensor_id%256;
	tmp_send_buf[size++] = PT_D_RTMON;
	tmp_send_buf[size++] = 0;
	//packet++ = (uint8)status;
	tmp_send_buf[size++] = (uint8)(pattern_sub_flag);   //̵

	//jhsong add 
	// ذ 
	tmp_send_buf[size++] = (uint8)(sens3_blz[0]);  //x
	tmp_send_buf[size++] = (uint8)(sens3_blz[0] >> 8);
	tmp_send_buf[size++] = (uint8)(sens3_blz[1]);  //y
	tmp_send_buf[size++] = (uint8)(sens3_blz[1] >> 8);
	tmp_send_buf[size++] = (uint8)(sens3_blz[2]);  //z
	tmp_send_buf[size++] = (uint8)(sens3_blz[2] >> 8);
					   
	  tmp_send_buf[size++] = (uint8)(x_result);  //9
	  tmp_send_buf[size++] = (uint8)(x_result >> 8);  //10

	  tmp_send_buf[size++] = (uint8)(y_result);
	  tmp_send_buf[size++] = (uint8)(y_result >> 8);

	  tmp_send_buf[size++] = (uint8)(z_result);
	  tmp_send_buf[size++] = (uint8)(z_result >> 8);                      

	tmp_send_buf[size++] = (uint8)(sens_blz_b[0]);  //15
	tmp_send_buf[size++] = (uint8)(sens_blz_b[0] >> 8);
	tmp_send_buf[size++] = (uint8)(sens_blz_b[1]);
	tmp_send_buf[size++] = (uint8)(sens_blz_b[1] >> 8);
	tmp_send_buf[size++] = (uint8)(sens_blz_b[2]);
	tmp_send_buf[size++] = (uint8)(sens_blz_b[2] >> 8);  //20
	
	//   
	tmp_send_buf[size++] = (uint8)diff_value_b[0];
	tmp_send_buf[size++] = (uint8)(diff_value_b[0] >> 8);
	tmp_send_buf[size++] = (uint8)diff_value_b[1];
	tmp_send_buf[size++] = (uint8)(diff_value_b[1] >> 8);
	tmp_send_buf[size++] = 0;                //ʱ  и 
	tmp_send_buf[size++] = pattern_force_serch;    // ̵ Ȳ
	
	tmp_send_buf[size++] = (uint8)stopcock_serch[0].flag;
	tmp_send_buf[size++] = (uint8)stopcock_serch[1].flag;
	tmp_send_buf[size++] = (uint8)stopcock_serch[2].flag;  
	tmp_send_buf[size++] = (uint8)(pattern_sort);       //ڼ   		//30
	tmp_send_buf[size++] = (uint8)(blz_add_tmp[0]);
	tmp_send_buf[size++] = (uint8)(blz_add_tmp[0] >> 8);
	tmp_send_buf[size++] = (uint8)(blz_add_tmp[1]);
	tmp_send_buf[size++] = (uint8)(blz_add_tmp[1] >> 8);
	tmp_send_buf[size++] = (uint8)(blz_add_tmp[2]); 
	tmp_send_buf[size++] = (uint8)(blz_add_tmp[2] >> 8);
	
	tmp_send_buf[size++] = (uint8)(stopcock_wait_time[0]);
	tmp_send_buf[size++] = (uint8)(stopcock_wait_time[0] >> 8);
	tmp_send_buf[size++] = (uint8)(stopcock_wait_time[1]);  
	tmp_send_buf[size++] = (uint8)(stopcock_wait_time[1] >> 8);  //40
	tmp_send_buf[size++] = (uint8)(stopcock_wait_time[2]);
	tmp_send_buf[size++] = (uint8)(stopcock_wait_time[2] >> 8);
						
	tmp_send_buf[size++] = (uint8)(stopcock_top[0]);
	tmp_send_buf[size++] = (uint8)(stopcock_top[0] >> 8);
	tmp_send_buf[size++] = (uint8)(stopcock_top[1]);
	tmp_send_buf[size++] = (uint8)(stopcock_top[1] >> 8);
	tmp_send_buf[size++] = (uint8)(stopcock_top[2]);
	tmp_send_buf[size++] = (uint8)(stopcock_top[2] >> 8);  //48

	tmp_send_buf[size++] = 0; 
	tmp_send_buf[size++] = (uint8)(car_in_out_vector[0][2]);
	tmp_send_buf[size++] = (uint8)(car_in_out_vector[0][2] >> 8);
	tmp_send_buf[size++] = (uint8)(car_in_out_vector[1][2]);
	tmp_send_buf[size++] = (uint8)(car_in_out_vector[1][2] >> 8);
	tmp_send_buf[size++] = (uint8)(car_in_out_vector[2][2]);
	tmp_send_buf[size++] = (uint8)(car_in_out_vector[2][2] >> 8);
	com_send_lora(tmp_send_buf, size);
}

